C MINIMUM Copyright (c) 1989, by Jonas Mockus
C You may give out copies of this software; for conditions see the
C file COPYING included with this distribution.                    

      SUBROUTINE EXTR(XM,BP,EP,YM,IPAR,PAR,IPA,IPAA)
C
C     INPUT: BP EP FI IPAR PAR IPA IPAA
C     OUTPUT:XM YM
C
C     XM	     POINT OF OPTIMUM
C     BP	     BEGINNING OF INTERVAL OF OPTIMIZATION
C     EP	     END OF INTERVAL OF OPTIMIZATION
C     YM	     OPTIMUM
C     FI(X,1)	     OBJECTIVE FUNCTION
C     IPAR(IPA+2)    MAXIMAL ALLOWABLE NUMBER OF EVALUATIONS OF FI
C     IPAR(IPA+3)    NUMBER OF EVALUATIONS OF FI FOR ESTIMATE OF MODEL
C		     PARAMETER
C     IPAR(IPA+1)    PRINTING PARAMETER
C		     <0 NO PRINTING
C		     =0 PRINTING OF OPTIMIZATION RESULTS
C		     =IP, PRINTING IN EACH IP ITERATION
C     PAR(IPAA+1)    ACCURACY OF YM
C     PAR(IPAA+2)    ACCURACY OF XM
C
      COMMON/PORT/NOUT
      COMMON /EXTR2/KAU,X2(506),Y2(506)
      COMMON/EXTR3/NS/STATIS/IFAIL,IT,ITM,N1/INW/IN
      COMMON/EXTR5/Y1(506)
      COMMON/EXTR6/X1(506)
      DOUBLE PRECISION EE1,EE2,EE3,DM17
      COMMON /EXTR1/A,YH,XJ1,XJ2,YJ1,YJ2
      DIMENSION IPAR(30),PAR(30)
      COMMON/EXTR8/CM5,CP5
C
      NOUT=I1MACH(2)
      RMAX=R1MACH(2)
      RMAXS=SQRT(RMAX)
      RMAX=ALOG10(RMAX)
      K=IFIX(RMAX)+1
      E1=PAR(IPAA+1)
      E2=PAR(IPAA+2)
      N=IPAR(IPA+2)
      NE=IPAR(IPA+3)
      IPAR3=IPAR(IPA+1)
      NS=0
      IN=1
      K1=K/3
      CUND=-2.0*FLOAT(K)
      CP5=10.0**(K1-1)
      CP6=10.0*CP5
      CM6=1.0/CP6
      CM5=1.0/CP5
      DM17=10.0D0 **(-K+2)
      CM17=DM17
      N2=NE+2
      IFAIL=0
      CALL INWR12(BP,EP,IPAR,PAR,IPA,IPAA,0.,0.)
      IF (IFAIL.EQ.10) RETURN
      A=AMIN1(BP,EP)
      EB=AMAX1(BP,EP)-A
      EB2=EB/25.0
   10 DA=EB/FLOAT(NE-1)
      N6=NE+3
      N1=0
      DO 20 J=4,N6
      X1(J)=A
      NS=NS+1
      Y=FI(A,1)
      N1=N1+1
      Y1(J)=Y
      IT=N1
      IF(J.EQ.4) GO TO 16
      IF (YM.LE.Y) GO TO 17
   16 YM=Y
      ITM=N1
      XM=A
   17 IF (ABS(Y).LT.RMAXS) GO TO 15
      IN=2
      CALL INWR12(BP,EP,IPAR,PAR,IPA,IPAA,A,Y)
      RETURN
   15 CONTINUE
      IF (IPAR3.LE.0) GO TO 20
      IF (MOD(N1,IPAR3).EQ.0) CALL SPAU12(XM,YM,X1(J),Y,IPAR3)
   20 A=A+DA
      A=0.0
      YMAX=Y1(4)
C
C     A IS ESTIMATE OF PARAMETER OF WIENER PROCESS
C     (PARAMETER OF MODEL OF FUNCTION F)
C
      DO 30 J=5,N6
      Y=Y1(J)
      A=A+(Y-Y1(J-1))**2
      IF (YMAX.LT.Y) YMAX=Y
   30 CONTINUE
      YH=YM-(YMAX-YM)/2.
      A=SQRT(A/EB)*20.
      IF(A.GE.CM6.AND.A.LE.CP6) GO TO 40
      IN=3
      CALL INWR12(BP,EP,IPAR,PAR,IPA,IPAA,0.,0.)
      RETURN
C
C     A IS EVALUATED. N5 IS THE NUMBER OF LOCAL OPTIMA
C     COMPUTED WITH ACCURACY E1,E2
C
   40 N5=0
      E1=AMIN1(E1,A*SQRT(EB2)*0.1)
      NP=N+6
      DO 50 J=1,NP
   50 Y2(J)=0.0
C
C     BAYESIAN STEP - FIND INTERVAL OF BIGGEST IMPROVEMENT (J)
C
   60 DO 70 J=4,N2
      IF(Y2(J).GT.0.0) GO TO 70
      XJ1=X1(J)
      XJ2=X1(J+1)
      YJ1=Y1(J)
      YJ2=Y1(J+1)
      Y2(J)=COR(X2(J))
   70 CONTINUE
   80 P1=Y2(4)
      J=4
      DO 90 N3=5,N2
      IF (Y2(N3).GE.P1) GO TO 90
      J=N3
      P1=Y2(N3)
   90 CONTINUE
      N4=NS-J+3
      DO 100 N3= 1,N4
      N7=NS+4-N3
      X1(N7+1)=X1(N7)
      Y1(N7+1)= Y1(N7)
      X2(N7)= X2(N7-1)
  100 Y2(N7)=Y2(N7-1)
      P1=X2(J)
       NS=NS+1
      Y=FI(P1,1)
      IF(Y.GT.YMAX) YMAX=Y
      X1(J+1)=P1
      Y1(J+1)=Y
      N4=1
      IF (Y.GE.YM) GO TO 110
      ITM=N1+1
      YM=Y
      XM=P1
      N4= 2
  110 N1=N1+1
      IF (ABS(Y).LT.RMAXS) GO TO 112
      IN=2
      CALL INWR12(BP,EP,IPAR,PAR,IPA,IPAA,P1,Y)
      IT=N1
      RETURN
  112 CONTINUE
      N2=NS+2
      IF (IPAR3.LE.0) GO TO 111
      IF (MOD(N1,IPAR3).EQ.0) CALL SPAU12(XM,YM,P1,Y,IPAR3)
  111 CONTINUE
C
C     IF NUMBER OF EVALUATIONS OF F MORE THAN (N-1) GO TO END
C
      IF(N1.LT.N) GO TO 115
      IFAIL=1
      GO TO 360
C
C     P4 IS PROBABILITY OF EVALUATING
C     XM,YM WITH ACCURACY E1,E2
C
  115 P4=1
      DO 120 N3=4,N2
      IF (Y2(N3).GE.0.) GO TO 120
      P1=-800.*((Y1(N3)-YM+E1)/A)*((Y1(N3+1)-YM+E1)/A)/(X1(N3+1)-X1(N3))
      IF(P1.LE.CUND) GO TO 120
      P4=P4*(1.0-EXP(P1))
  120 CONTINUE
C
C     IF P4 MORE THAN 0.95, THEN
C     GO TO END OF EXTR
C
      YH=YM-(YMAX-YM)/2.
      IF (ABS(YM-Y).LT.R1MACH(1)*1.E+3) GO TO 130
      IF (P4.GE.0.95) GO TO 360
C
C     IF N5=0 A IS UPDATED IN EACH FIFTH STEP
C
      IF (MOD(NS,5).NE.0.OR.N5.GT.0) GO TO 160
  130 A=0.
      N4=2
      DO 150 N3=4,N2
  150 A=A+((Y1(N3+1)-Y1(N3))**2)/(X1(N3+1)-X1(N3))
      A=SQRT(A/FLOAT(NS-1))*20.
C
C     PREPARATION OF BOUNDS OF X1,Y1 FOR TESTING-
C     IS INTERVAL OF LOCAL OPTIMUM  FOUND
C
  160 X1(3)=(3.0*X1(4)-X1 (5))/2.0
      X1(1)=X1(3)
      X1(2)=X1(3)
      X1(NS+4)=(3.0*X1(NS+3)-X1(NS+2))/2.0
      X1(NS+5)=X1(NS+4)
      X1(NS+6)=X1(NS+4)
      NR=NS+3
      DO 170 N3=1,3
      Y1(N3)=Y1(5)
      NR3=NR+N3
  170 Y1(NR3)  =Y1(N2)
      N7=MAX0(1,J-5)
      N8=MIN0(NS,J+1)
C
C     TEST IF INTERVAL OF LOCAL OPTIMUM FOUND
C
      DO 180 N3=N7,N8
      IF ( Y1(N3).GE.Y1(N3+1).AND. Y1(N3+1).GE.Y1(N3+2)
     *.AND.Y1(N3+2).GT.Y1(N3+3).AND.Y1(N3+3).LT.Y1(N3+4)
     *.AND.Y1(N3+4).LE.Y1(N3+5).AND.Y1(N3+5).LE.Y1(N3+6)
     *.AND.(X1(N3+6)-X1(N3)).LE.(EB/5.0)) GO TO 200
  180 CONTINUE
      GO TO 310
C
C     BEGINING OF LOCAL OPTIMIZATION
C
  200 N6=N3+5
      DO 210 N7=N3,N6
  210 Y2(N7)=1.
      N3=N3+3
      N5=N5+1
      P3=X1(1)
      XL1=X1(N3-1)
      XL2=X1(N3)
      XL3=X1(N3+1)
      YL1=Y1(N3-1)
      YL2=Y1(N3)
      YL3=Y1(N3+1)
      N8=0
  220 EE1=DBLE(YL1-YL2)
      EE2=DBLE(XL1-XL2)
      IF (DABS(EE1).LE.DM17.OR.DABS(EE2).LE.DM17) GO TO 300
      EE3=DBLE(2.*(YL1-YL3))/EE1-DBLE(2.*(XL1-XL3))/EE2
      IF (DABS(EE3).LE.DM17) GO TO 300
      XA=(DBLE(XL1+XL2)*DBLE(YL1-YL3)/EE1-DBLE(XL1-XL3)*DBLE(XL1+XL3)/
     *EE2)/EE3
      EE3=DBLE(XL2-XA)
      EE2=DBLE(XL1-XA)
      IF (DABS(EE2).GE.DM17) GO TO 230
      P1=YL1
      GO TO 250
  230 EE3=1.0D0-(EE3/EE2)**2
      IF (DABS(EE3).GE.DM17) GO TO 240
      IF (EE1.LE.DABS(EE3)*1.0D6) GO TO 240
      P1=YL1-1.0E5
      GO TO 250
  240 EE1=EE1/EE3
      P1=YL1-EE1
  250 YA=FI(XA,1)
      P3=ABS(XA-P3)
      IF (YA.GE.YM) GO TO 260
      YM=YA
      ITM=N1+1
      XM=XA
      YH=YM-(YMAX-YM)/2.
  260 N7=1
      IF (ABS(YA).LT.RMAXS) GO TO 251
      IN=2
      CALL INWR12(BP,EP,IPAR,PAR,IPA,IPAA,XA,YA)
      IT=N1
      RETURN
  251 CONTINUE
      N1=N1+1
      IF (N1.LT.N) GO TO 261
      IFAIL=1
      GO TO 360
  261 CONTINUE
      IF (IPAR3.LE.0) GO TO 262
      IF (MOD(N1,IPAR3).EQ.0) CALL SPAU12(XM,YM,XA,YA,IPAR3)
  262 CONTINUE
      IF (XA.GT.XL2) N7=2
      P2=ABS(P1-YA)
      JAU=0
      IF((P2.LE.E1.AND.P3.LE.E2).OR.P2.LE.CM17.OR.P3.LE.CM17)JAU=1
      IF (YA.GE.YL2) GO TO 280
      IF (N7.EQ.1) GO TO 270
      XL1=XL2
      YL1=YL2
      XL2=XA
      YL2=YA
  265 IF (N3.EQ.NS+3.AND.N8.EQ.0) GO TO 267
      N8=1
      GO TO 290
  267 XL3=(3.*XL2-XL1)/2.
      YL3=YL1
      GO TO 290
  270 XL3=XL2
      YL3=YL2
      XL2=XA
      YL2=YA
  275 IF (N3.EQ.4.AND.N8.EQ.0) GO TO 277
      N8=1
      GO TO 290
  277 XL1=(3.*XL2-XL3)/2.
      YL1=YL3
      GO TO 290
  280 IF (N7.EQ.1) GO TO 285
      XL3=XA
      YL3=YA
      GO TO 275
  285 XL1=XA
      YL1=YA
      GO TO 265
  290 P3=XA
      IF (JAU.EQ.0) GO TO 220
  300 X1(N3)=XL2
      Y1(N3)=YL2
  305 N4=2
  310 CONTINUE
      IF(N4.EQ.2) GO TO 60
      N7=J+1
      DO 330 N3=J,N7
      XJ1=X1(N3)
      XJ2=X1(N3+1)
      YJ1=Y1(N3)
      YJ2=Y1(N3+1)
      IF((XJ2-XJ1).LT.EB2.AND.Y2(N3-1).GT.0.0.AND.
     *YJ1.LT.YJ2) GO TO 320
      Y2(N3)=COR(X2(N3))
      GO TO 330
  320 Y2(N3)=1.
  330 CONTINUE
      IF (Y2(N7+1).GT.0.0.AND.Y1(N7).GT.Y1(N7+1).AND.
     *(X1(N7+1)-X1(N7)).LT.EB2) Y2(N7)=1.0
      IF( Y2(N7).GT.0.0 .AND. Y1(N7-1).GT.Y1(N7).AND.
     *(X1(N7)-X1(N7-1)).LT.EB2) Y2(N7-1)=1.0
      GO TO 80
  360 IN=4
      N2=NS+3
      KAU=0
      DO 370 I=4,N2
      IF (.NOT.((Y1(I).LE.Y1(I-1)).AND.(Y1(I).LE.Y1(I+1)).AND.(Y2(I-1)
     C.GT.0.))) GO TO 370
      KAU=KAU+1
      X2(KAU)=X1(I)
      Y2(KAU)=Y1(I)
  370 CONTINUE
      IF (IPAR3.GE.0) CALL SPAU12(XM,YM,0.,0.,IPAR3)
      IT=N1
       RETURN
      END
      FUNCTION COR(X)
      COMMON /EXTR1/C,YH,XJ1,XJ2,YJ1,YJ2
      X=(XJ1+XJ2)/2.+(XJ2-XJ1)*(YJ1-YJ2)*0.5 /(YJ1+YJ2-2.*YH)
      AM=((XJ2-X)*YJ1+(X-XJ1)*YJ2)/(XJ2-XJ1)
      D=SQRT((XJ2-X)*(X-XJ1)/(XJ2-XJ1))*C
      COR=-ALNORM((YH-AM)/D,.FALSE.)
      RETURN
      END
      FUNCTION ALNORM(X,UPPER)
      REAL LTONE,UTZERO,ZERO,HALF,ONE,CON,Z,Y,X
      LOGICAL UPPER,UP
      DATA  LTONE/7.0/, UTZERO/18.66/
      DATA  ZERO/0./, HALF/0.5/, ONE/1./, CON/1.28/
      UP=UPPER
      Z=X
      IF (Z.GE.ZERO) GO TO 10
      UP= .NOT.UP
      Z=-Z
   10 IF (Z.LE.LTONE.OR.UP.AND.Z.LE.UTZERO) GO TO 20
      ALNORM=ZERO
      GO TO 40
   20 Y=HALF*Z*Z
      IF (Z.GT.CON) GO TO 30
      ALNORM=HALF-Z*(0.398942280444-0.399903438504*Y/(Y+5.75885480458-
     129.8213557808/(Y+2.62433121679+48.6959930692/(Y+5.92885724438))))
      GO TO 40
   30 ALNORM=0.398942280385*EXP(-Y)/(Z-3.8052E-8+1.00000615302/(Z+
     13.98064794E-4+1.98615381364/(Z-0.151679116635+5.29330324926/
     2(Z+4.8385912808-15.1508972451/(Z+0.742380924027+30.789933034/
     3(Z+3.99019417011))))))
   40 IF (.NOT.UP) ALNORM=ONE-ALNORM
      RETURN
      END
      SUBROUTINE SPAU12(XM,YM,X,FF,IPR)
      COMMON /INW/IN/EXTR2/KAU,X2(506),Y2(506)/STATIS/IFAIL,IT,ITM,L
      NOUT=I1MACH(2)
      IF (IN.EQ.4) GO TO 10
      WRITE (NOUT,100)
      IF (L.EQ.IPR) WRITE (NOUT,210)
      WRITE (NOUT,110) L
      WRITE (NOUT,120) FF
      WRITE (NOUT,130) X
      IF (L.EQ.1) RETURN
      WRITE (NOUT,150) YM
      WRITE (NOUT,160) XM
      RETURN
   10 WRITE (NOUT,170)
      WRITE (NOUT,180)
      WRITE (NOUT,150) YM
      WRITE (NOUT,160) XM
      IF (KAU.EQ.0) GO TO 30
      WRITE (NOUT,250)
      DO 20 I=1,KAU
      WRITE (NOUT,220) X2(I),Y2(I)
   20 CONTINUE
   30 CONTINUE
      WRITE (NOUT,230)
      WRITE (NOUT,110) L
      IF (IFAIL.EQ.1) WRITE (NOUT,240)
      IF (IFAIL.EQ.0) WRITE (NOUT,260)
      WRITE (NOUT,270)
      WRITE (NOUT,170)
      RETURN
  100 FORMAT (/1X,34(2H -))
  110 FORMAT (2X,34HNUMBER OF FUNCTION EVALUATIONS L =,I6)
  120 FORMAT (/2X,19HFUNCTION VALUE F = ,E15.8)
  130 FORMAT (2X,19HCURRENT POINT  X = ,E15.8)
  150 FORMAT (/2X,28HOPTIMAL FUNCTION VALUE FM = ,E15.8)
  160 FORMAT (2X,13HOPTIMAL POINT,10X,5HXM = ,E15.8)
  170 FORMAT (/1X,34(2H *)/1X,34(2H *))
  180 FORMAT (/2X,13HR E S U L T S)
  210 FORMAT (1X,34(2H -))
  220 FORMAT (2X,E15.8,3X,E15.8)
  230 FORMAT (/)
  240 FORMAT (/2X,52HIFAIL = 1. TERMINATION CRITERION: NUMBER OF FUNCTIO
     CN/2X,20HEVALUATIONS EQUALS M)
  250 FORMAT (/12X,12HLOCAL OPTIMA/7X,5HPOINT,9X,14HFUNCTION VALUE)
  260 FORMAT(/2X,67HIFAIL = 0. TERMINATION CRITERION: PROBABILITY OF FIN
     CDING THE GLOBAL/2X,45HOPTIMUM WITH GIVEN ACCURACY IS MORE THAN 0.9
     C5)
  270 FORMAT (/7X,15HEXTR TERMINATED)
      END
      SUBROUTINE INWR12(A,B,IPAR,PAR,IPA,IPAA,X,Y)
      DIMENSION IPAR(30),PAR(30)
      COMMON /INW/IN/STATIS/IFAIL,IT,ITM,N1
      COMMON /EXTR8/CM5,CP5
      NOUT=I1MACH(2)
      GO TO (2,280,270),IN
    2 CONTINUE
      MIP=30
      K=3
      IF (IPA.GE.0.AND.IPA+K.LE.MIP) GO TO 10
      WRITE (NOUT,520) K,MIP
      WRITE (NOUT,510) IPA
    5 IFAIL=10
      RETURN
   10 CONTINUE
      MM=500
      MIM=6
      K1=2
      IPRINT=IPAR(IPA+1)
      M=IPAR(IPA+2)
      LT=IPAR(IPA+3)
      IF (IPRINT.LT.0) GO TO 40
      WRITE (NOUT,690)
      WRITE (NOUT,620)
      WRITE (NOUT,640) IPRINT
      WRITE (NOUT,650) M
      WRITE (NOUT,660) LT
   40 IF (M.GT.0.AND.M.LE.MM) GO TO 50
      WRITE (NOUT,525) MM
      IF (IPRINT.LT.0) WRITE (NOUT,650) M
      GO TO 5
   50 CONTINUE
      IF (LT.GE.MIM.AND.LT.LE.M) GO TO 80
      WRITE (NOUT,550) MIM
      IF (IPRINT.GE.0) GO TO 5
      WRITE (NOUT,660) LT
      WRITE (NOUT,650) M
      GO TO 5
   80 CONTINUE
      IF (IPAA.GE.0.AND.IPAA+K1.LE.MIP) GO TO 240
      WRITE (NOUT,710) K1,MIP
      WRITE (NOUT,700) IPAA
      GO TO 5
  240 E1=PAR(IPAA+1)
      E2=PAR(IPAA+2)
      IF (IPRINT.LT.0) GO TO 250
      WRITE (NOUT,720) E1
      WRITE (NOUT,730) E2
      WRITE (NOUT,740) A,B
  250 CONTINUE
      EB=AMAX1(A,B)-AMIN1(A,B)
      IF ((EB.GE.CM5).AND.(EB.LE.CP5)) GO TO 260
      WRITE (NOUT,750)
      IF (IPRINT.LT.0) WRITE (NOUT,740) A,B
      GO TO 5
  260 RETURN
  270 WRITE (NOUT,760)
      IF (IPAR(IPA+1).GE.0) GO TO 5
      WRITE (NOUT,660) LT
      WRITE (NOUT,740) A,B
      GO TO 5
  280 WRITE (NOUT,770) Y,X
      GO TO 5
  510 FORMAT (/2X,20HNUMBER OF PARAMETERS,11X,5HIPA =,I6)
  520 FORMAT (/2X,43H**E R R O R  I N  E X T R** IPA LESS THAN 0/2X,
     C7HOR IPA+,I2,13H GREATER THAN,I3)
  525 FORMAT (/2X,41H**E R R O R  I N  E X T R** M LESS THAN 1/2X,
     C17HOR M GREATER THAN,I6/)
  550 FORMAT (/2X,40H**E R R O R  I N  E X T R** LT LESS THAN,I3/2X,
     C20HOR LT GREATER THAN M/)
  620 FORMAT (/2X,22HI N I T I A L  D A T A)
  640 FORMAT (/2X,18HPRINTING PARAMETER,38X,5HIPR =,I6)
  650 FORMAT (2X,38HMAXIMUM NUMBER OF FUNCTION EVALUATIONS,20X,3HM =,I6)
  660 FORMAT (2X,61HNUMBER OF FUNCTION EVALUATIONS FOR PARAMETER ESTIMAT
     CION  LT =,I6)
  690 FORMAT (////12X,7HE X T R)
  700 FORMAT (/2X,27HNUMBER OF PARAMETERS IPAA =,I3)
  710 FORMAT (/2X,44H**E R R O R  I N  E X T R** IPAA LESS THAN 0/2X,
     C8HOR IPAA+,I2,13H GREATER THAN,I3)
  720 FORMAT (/2X,41HACCURACY OF OPTIMAL FUNCTION VALUE EPS1 =,E15.8)
  730 FORMAT (2X,25HACCURACY OF OPTIMAL POINT,10X,6HEPS2 =,E15.8)
  740 FORMAT (/2X,23HLOWER BOUND (A) FOR X =,E15.8/2X,23HUPPER BOUND (B)
     C FOR X =,E15.8)
  750 FORMAT (/2X,44H**E R R O R  I N  E X T R** BOUNDS FOR X ARE/
     C2X,22HTOO SMALL OR TOO LARGE)
  760 FORMAT (/2X,66H**E R R O R  I N  E X T R** VARIATION OF OBJECTIVE
     CFUNCTION IS TOO/2X,62HSMALL OR TOO LARGE. TRY TO CHANGE LT TO LT*2
     C+1 OR BOUNDS FOR X/)
  770 FORMAT (/2X,52H**E R R O R  I N  E X T R** TOO LARGE FUNCTION VALU
     CE//2X,3HF =,E15.8,2X,3HX =,E15.8)
      END
